# -*- coding: utf-8 -*-
# Generated by Django 1.11.5 on 2017-09-13 11:27
from __future__ import unicode_literals

from csv import DictReader
import io
from urllib.request import urlopen

from django.db import migrations


from 臺灣言語工具.解析整理.文章粗胚 import 文章粗胚
from 臺灣言語工具.音標系統.閩南語.臺灣閩南語羅馬字拼音 import 臺灣閩南語羅馬字拼音
from 臺灣言語工具.解析整理.拆文分析器 import 拆文分析器


def 匯入用字(app, editor):
    用字表 = app.get_model("用字", "用字表")
    for 字物件 in 教典資料.全部資料():
        用字表.objects.get_or_create(分詞=字物件.轉音(臺灣閩南語羅馬字拼音).看分詞())


class 教典資料:
    例句網址 = 'https://github.com/g0v/moedict-data-twblg/raw/master/uni/%E4%BE%8B%E5%8F%A5.csv'

    @classmethod
    def 全部資料(cls):
        with urlopen(cls.例句網址) as 檔:
            with io.StringIO(檔.read().decode()) as 資料:
                for row in DictReader(資料):
                    音讀 = row['例句標音'].strip()
                    漢字 = row['例句'].strip()
                    整理後漢字 = 文章粗胚.建立物件語句前處理減號(臺灣閩南語羅馬字拼音, 漢字)
                    整理後臺羅 = 文章粗胚.建立物件語句前處理減號(臺灣閩南語羅馬字拼音, 音讀)
                    try:
                        for 字物件 in (
                            拆文分析器
                            .對齊句物件(整理後漢字, 整理後臺羅)
                            .篩出字物件()
                        ):
                            yield 字物件
                    except Exception as 錯誤:
                        print(錯誤)


class Migration(migrations.Migration):

    dependencies = [
        ('用字', '0002_匯入資料'),
    ]

    operations = [
        # migrations.RunPython(匯入用字, lambda *x:x),
    ]
